## fenics-dolfinx 0.9.0

=== cpp/CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Top level CMakeLists.txt file for DOLFINx
cmake_minimum_required(VERSION 3.21)

if(POLICY CMP0167)
  cmake_policy(SET CMP0167 NEW)  # Boost CONFIG mode
endif()

# ------------------------------------------------------------------------------
# Set project name and version number
project(DOLFINX VERSION "0.9.0")

set(DOXYGEN_DOLFINX_VERSION
    ${DOLFINX_VERSION}
    CACHE STRING "Version for Doxygen" FORCE
)

# ------------------------------------------------------------------------------
if(WIN32)
  # Windows requires all symbols to be manually exported. This flag exports all
  # symbols automatically, as in Unix.
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
endif()

# ------------------------------------------------------------------------------
# Get GIT changeset, if available
find_program(GIT_FOUND git)

if(GIT_FOUND)
  # Get the commit hash of the working branch
  execute_process(
    COMMAND git rev-parse HEAD
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
else()
  set(GIT_COMMIT_HASH "unknown")
endif()

# ------------------------------------------------------------------------------
# General configuration

# Set location of our FindFoo.cmake modules
set(CMAKE_MODULE_PATH "${DOLFINX_SOURCE_DIR}/cmake/modules")

# Make sure CMake uses the correct DOLFINConfig.cmake for tests and demos
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/dolfinx)

# ------------------------------------------------------------------------------
# Configurable options for how we want to build
include(FeatureSummary)

option(BUILD_SHARED_LIBS "Build DOLFINx with shared libraries." ON)
add_feature_info(
  BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build DOLFINx with shared libraries."
)

# If libdolfinx links to a symbol contained in an external dll, that dll will be
# installed alongside libdolfinx. This excludes system dlls included with
# Windows.
option(INSTALL_RUNTIME_DEPENDENCIES
       "Include runtime dependencies in install (Windows-only)" OFF
)
add_feature_info(
  INSTALL_RUNTIME_DEPENDENCIES INSTALL_RUNTIME_DEPENDENCIES
  "Include runtime dependencies in install (Windows-only)"
)

option(DOLFINX_SKIP_BUILD_TESTS
       "Skip build tests for testing usability of dependency packages." OFF
)
add_feature_info(
  DOLFINX_SKIP_BUILD_TESTS DOLFINX_SKIP_BUILD_TESTS
  "Skip build tests for testing usability of dependency packages."
)

# Add shared library paths so shared libs in non-system paths are found
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH
       "Add paths to linker search and installed rpath." ON
)
add_feature_info(
  CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH
  "Add paths to linker search and installed rpath."
)

# Control Basix discovery
option(
  DOLFINX_BASIX_PYTHON
  "Ask Python basix module for hint where to find Basix C++ install using CONFIG mode."
  ON
)
add_feature_info(
  DOLFINX_BASIX_PYTHON
  DOLFINX_BASIX_PYTHON
  "Ask Python basix module for hint where to find Basix C++ install using CONFIG mode."
)

# Control UFCx discovery
option(
  DOLFINX_UFCX_PYTHON
  "Ask Python FFCx module where to find ufcx.h header using MODULE mode. Otherwise use CONFIG mode."
  ON
)
add_feature_info(
  DOLFINX_UFCX_PYTHON
  DOLFINX_UFCX_PYTHON
  "Ask Python FFCx module where to find ufcx.h header using MODULE mode. Otherwise use CONFIG mode."
)

# ------------------------------------------------------------------------------
# Enable or disable optional packages

if(DOLFINX_ENABLE_ADIOS2)
  set(_REQUIRE_ADIOS2
      TRUE
      CACHE BOOL "Is ADIOS2 REQUIRED?"
  )
else()
  set(_REQUIRE_ADIOS2
      FALSE
      CACHE BOOL "Is ADIOS2 REQUIRED?"
  )
endif()
option(DOLFINX_ENABLE_ADIOS2 "Compile with support for ADIOS2." ON)
set_package_properties(
  ADIOS2 PROPERTIES
  TYPE OPTIONAL
  DESCRIPTION "Adaptable Input/Output (I/O) System."
  URL "https://adios2.readthedocs.io/en/latest/"
  PURPOSE "IO, including in parallel"
)

if(DOLFINX_ENABLE_PETSC)
  set(_REQUIRE_PETSC
      TRUE
      CACHE BOOL "Is PETSc REQUIRED?"
  )
else()
  set(_REQUIRE_PETSC
      FALSE
      CACHE BOOL "Is PETSc REQUIRED?"
  )
endif()

option(DOLFINX_ENABLE_PETSC "Compile with support for PETSc." ON)
set_package_properties(
  PETSc PROPERTIES
  TYPE RECOMMENDED
  DESCRIPTION "Portable, Extensible Toolkit for Scientific Computation"
  URL "https://petsc.org/"
  PURPOSE "Linear and nonlinear solvers"
)

if(DOLFINX_ENABLE_PARMETIS)
  set(_REQUIRE_PARMETIS
      TRUE
      CACHE BOOL "Is Parmetis REQUIRED?"
  )
else()
  set(_REQUIRE_PARMETIS
      FALSE
      CACHE BOOL "Is Parmetis REQUIRED?"
  )
endif()
option(DOLFINX_ENABLE_PARMETIS "Compile with support for ParMETIS." ON)
set_package_properties(
  ParMETIS PROPERTIES
  TYPE RECOMMENDED
  DESCRIPTION "Parallel Graph Partitioning and Fill-reducing Matrix Ordering"
  URL "http://glaros.dtc.umn.edu/gkhome/metis/parmetis/overview"
  PURPOSE "Parallel graph partitioning"
)

if(DOLFINX_ENABLE_SCOTCH)
  set(_REQUIRE_SCOTCH
      TRUE
      CACHE BOOL "Is SCOTCH REQUIRED?"
  )
else()
  set(_REQUIRE_SCOTCH
      FALSE
      CACHE BOOL "Is SCOTCH REQUIRED?"
  )
endif()
option(DOLFINX_ENABLE_SCOTCH "Compile with support for SCOTCH." ON)
set_package_properties(
  SCOTCH PROPERTIES
  TYPE OPTIONAL
  DESCRIPTION
    "Programs and libraries for graph, mesh and hypergraph partitioning"
  URL "https://www.labri.fr/perso/pelegrin/scotch"
  PURPOSE "Parallel graph partitioning"
)

if(DOLFINX_ENABLE_SLEPC)
  set(_REQUIRE_SLEPC
      TRUE
      CACHE BOOL "Is SLEPc REQUIRED?"
  )
else()
  set(_REQUIRE_SLEPC
      FALSE
      CACHE BOOL "Is SLEPc REQUIRED?"
  )
endif()
option(DOLFINX_ENABLE_SLEPC "Compile with support for SLEPc." ON)
set_package_properties(
  SLEPc PROPERTIES
  TYPE RECOMMENDED
  DESCRIPTION "Scalable Library for Eigenvalue Problem Computations"
  URL "http://slepc.upv.es/"
  PURPOSE "Eigenvalue computation"
)

if(DOLFINX_ENABLE_KAHIP)
  set(_REQUIRE_KAHIP
      TRUE
      CACHE BOOL "Is KaHIP REQUIRED?"
  )
else()
  set(_REQUIRE_KAHIP
      FALSE
      CACHE BOOL "Is KaHIP REQUIRED?"
  )
endif()
option(DOLFINX_ENABLE_KAHIP "Compile with support for KaHIP." ON)
set_package_properties(
  KaHIP PROPERTIES
  TYPE OPTIONAL
  DESCRIPTION "A family of graph partitioning programs"
  URL "https://kahip.github.io/"
  PURPOSE "Parallel graph partitioning"
)

# ------------------------------------------------------------------------------
# Check for MPI
find_package(MPI 3 REQUIRED)

find_package(spdlog REQUIRED)
# ------------------------------------------------------------------------------
# Compiler flags

# Default build type (can be overridden by user)
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE
      "RelWithDebInfo"
      CACHE
        STRING
        "Choose the type of build, options are: Debug Developer MinSizeRel Release RelWithDebInfo."
        FORCE
  )
endif()

# Check for some compiler flags
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-pipe HAVE_PIPE)

if(HAVE_PIPE)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -pipe)
endif()

# Add some strict compiler checks
check_cxx_compiler_flag("-Wall -Werror -Wextra -pedantic" HAVE_PEDANTIC)

if(HAVE_PEDANTIC)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -Wall;-Werror;-Wextra;-pedantic)
endif()

# Debug flags
check_cxx_compiler_flag(-g HAVE_DEBUG)

if(HAVE_DEBUG)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -g)
endif()

# Optimisation
check_cxx_compiler_flag(-O2 HAVE_O2_OPTIMISATION)

if(HAVE_O2_OPTIMISATION)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -O2)
endif()

# Turn off some checks in gcc12 and gcc13 due to false positives with the fmt
# library
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
   AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "11.4"
   AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "14.0")
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS
       -Wno-array-bounds;-Wno-stringop-overflow)
endif()

# ------------------------------------------------------------------------------
# Find required packages

# pugixml
find_package(pugixml REQUIRED)

# Note: When updating Boost version, also update DOLFINXConfig.cmake.in
if(DEFINED ENV{BOOST_ROOT} OR DEFINED BOOST_ROOT)
  set(Boost_NO_SYSTEM_PATHS on)
endif()

set(Boost_USE_MULTITHREADED $ENV{BOOST_USE_MULTITHREADED})
set(Boost_VERBOSE TRUE)
find_package(Boost 1.70 REQUIRED timer)
set_package_properties(
  Boost PROPERTIES
  TYPE REQUIRED
  DESCRIPTION "Boost C++ libraries"
  URL "http://www.boost.org"
)

# Basix C++ files can be installed as a standalone C++ library, or in the Basix
# Python module tree.

# If requested (default), ask the Python interpreter for hints on where to find
# Basix C++ library.
if(DOLFINX_BASIX_PYTHON)
  find_package(
    Python3
    COMPONENTS Interpreter
    QUIET
  )

  if(Python3_Interpreter_FOUND)
    message(STATUS "Checking for Basix hints with ${Python3_EXECUTABLE}")
    execute_process(
      COMMAND
        ${Python3_EXECUTABLE} -c
        "import basix, os, sys; sys.stdout.write(os.path.dirname(basix.__file__))"
      OUTPUT_VARIABLE BASIX_PY_DIR
      RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
      ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  endif()

  if(BASIX_PY_DIR)
    # Converts os native to cmake native path
    cmake_path(SET BASIX_PY_DIR "${BASIX_PY_DIR}")
    message(STATUS "Adding ${BASIX_PY_DIR} to Basix search hints")

    # Basix installed from manylinux wheel requires rpath set.
    if(IS_DIRECTORY ${BASIX_PY_DIR}/../fenics_basix.libs)
      set(CMAKE_INSTALL_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
    endif()
  else()
    message(STATUS "No Basix hint was found.")
  endif()
endif()

find_package(Basix 0.8 REQUIRED CONFIG HINTS ${BASIX_PY_DIR})
set_package_properties(
  basix PROPERTIES
  TYPE REQUIRED
  DESCRIPTION "FEniCS tabulation library"
  URL "https://github.com/fenics/basix"
)

# Check for HDF5
set(HDF5_PREFER_PARALLEL TRUE)
set(HDF5_FIND_DEBUG TRUE)
find_package(HDF5 REQUIRED COMPONENTS C)

if(NOT HDF5_IS_PARALLEL)
  message(
    FATAL_ERROR
      "Found serial HDF5 build, MPI HDF5 build required, try setting HDF5_DIR or HDF5_ROOT"
  )
endif()

set_package_properties(
  HDF5 PROPERTIES
  TYPE REQUIRED
  DESCRIPTION "Hierarchical Data Format 5 (HDF5)"
  URL "https://www.hdfgroup.org/HDF5"
)

# Check for UFC Note: we use the case (ufcx vs UFCx) elsewhere to determine by
# which method UFCx was found.
if(NOT DOLFINX_UFCX_PYTHON)
  # Check in CONFIG mode, i.e. look for installed ufcxConfig.cmake
  find_package(ufcx 0.9 REQUIRED CONFIG)
else()
  # Check in MODULE mode (using FindUFCX.cmake) using Python intepreter.
  find_package(
    Python3
    COMPONENTS Interpreter
    REQUIRED
  )
  find_package(UFCx 0.9 REQUIRED MODULE)
endif()

set_package_properties(
  UFCx PROPERTIES
  TYPE REQUIRED
  DESCRIPTION "Interface for form-compilers (part of FFCx)"
  URL "https://github.com/fenics/ffcx"
)

# ------------------------------------------------------------------------------
# Find optional packages
if(DOLFINX_ENABLE_ADIOS2 AND _REQUIRE_ADIOS2)
  find_package(ADIOS2 2.8.1 REQUIRED)
elseif(DOLFINX_ENABLE_ADIOS2)
  find_package(ADIOS2 2.8.1)
endif()
if(ADIOS2_FOUND AND NOT ADIOS2_HAVE_MPI)
  message(
    FATAL_ERROR
      "Found serial ADIOS2 build, MPI ADIOS2 build required, try setting ADIOS2_DIR or ADIOS2_ROOT"
  )
endif()

if(DOLFINX_ENABLE_PETSC)
  find_package(PkgConfig REQUIRED)
  set(ENV{PKG_CONFIG_PATH}
      "$ENV{PETSC_DIR}/$ENV{PETSC_ARCH}/lib/pkgconfig:$ENV{PETSC_DIR}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}"
  )
  if(_REQUIRE_PETSC)
    pkg_search_module(PETSC REQUIRED IMPORTED_TARGET PETSc>=3.15 petsc>=3.15)
  else()
    pkg_search_module(PETSC OPTIONAL IMPORTED_TARGET PETSc>=3.15 petsc>=3.15)
  endif()

  # Setting for FeatureSummary
  if(PETSC_FOUND)
    message(
      STATUS "Found PETSc version ${PETSC_VERSION}, prefix: ${PETSC_PREFIX}"
    )
    set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND PETSc)
  else()

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

project(dolfinx_nanobind)

if(WIN32)
  # Windows requires all symbols to be manually exported. This flag exports all
  # symbols automatically, as in Unix.
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
endif(WIN32)

find_package(
  Python
  COMPONENTS Interpreter Development
  REQUIRED
)

# Detect the installed nanobind package and import it into CMake
execute_process(
  COMMAND "${Python_EXECUTABLE}" -m nanobind --cmake_dir
  OUTPUT_STRIP_TRAILING_WHITESPACE
  OUTPUT_VARIABLE NB_DIR
)
list(APPEND CMAKE_PREFIX_PATH "${NB_DIR}")
find_package(nanobind CONFIG REQUIRED)

find_package(DOLFINX REQUIRED CONFIG)

if(DOLFINX_FOUND)
  message(STATUS "Found DOLFINx at ${DOLFINX_DIR}")
endif()

# Create the binding library nanobind handles its own calls to
# target_link_libraries
nanobind_add_module(
  cpp
  NOMINSIZE
  dolfinx/wrappers/dolfinx.cpp
  dolfinx/wrappers/assemble.cpp
  dolfinx/wrappers/common.cpp
  dolfinx/wrappers/fem.cpp
  dolfinx/wrappers/geometry.cpp
  dolfinx/wrappers/graph.cpp
  dolfinx/wrappers/io.cpp
  dolfinx/wrappers/la.cpp
  dolfinx/wrappers/log.cpp
  dolfinx/wrappers/mesh.cpp
  dolfinx/wrappers/petsc.cpp
  dolfinx/wrappers/refinement.cpp
)
target_compile_definitions(cpp PRIVATE cxx_std_20)

# Add DOLFINx libraries
target_link_libraries(cpp PRIVATE dolfinx)
# UUID requires bcrypt to be linked on Windows, broken in vcpkg.
# https://github.com/microsoft/vcpkg/issues/4481
if(WIN32)
  target_link_libraries(cpp PRIVATE bcrypt)
endif()

# Check for petsc4py
execute_process(
  COMMAND ${Python_EXECUTABLE} -c
          "import petsc4py; print(petsc4py.get_include())"
  OUTPUT_VARIABLE PETSC4PY_INCLUDE_DIR
  RESULT_VARIABLE PETSC4PY_COMMAND_RESULT
  ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(NOT PETSC4PY_COMMAND_RESULT)
  message(STATUS "Found petsc4py include directory at ${PETSC4PY_INCLUDE_DIR}")
  target_include_directories(cpp PRIVATE ${PETSC4PY_INCLUDE_DIR})
  target_compile_definitions(cpp PRIVATE HAS_PETSC4PY)
else()
  message(STATUS "petsc4py not found.")
endif()

# Check for mpi4py
execute_process(
  COMMAND "${Python_EXECUTABLE}" -c "import mpi4py; print(mpi4py.get_include())"
  OUTPUT_VARIABLE MPI4PY_INCLUDE_DIR
  RESULT_VARIABLE MPI4PY_COMMAND_RESULT
  ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(NOT MPI4PY_COMMAND_RESULT)
  message(STATUS "Found mpi4py include directory at ${MPI4PY_INCLUDE_DIR}")
  target_include_directories(cpp PRIVATE ${MPI4PY_INCLUDE_DIR})
else()
  message(FATAL_ERROR "mpi4py could not be found.")
endif()

set_target_properties(cpp PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)

install(TARGETS cpp DESTINATION dolfinx)

=== cpp/demo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(dolfinx-demos)

# Find DOLFINx config file
find_package(DOLFINX REQUIRED)

# Enable testing
enable_testing()

# Macro to add demos. Some subdirectories might be skipped because demos may not
# be running in both real and complex modes.
macro(add_demo_subdirectory subdir)
  if(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${subdir})
    add_subdirectory(${subdir})
  endif()
endmacro(add_demo_subdirectory)

# Add demos
add_demo_subdirectory(biharmonic)
add_demo_subdirectory(codim_0_assembly)
add_demo_subdirectory(custom_kernel)
add_demo_subdirectory(poisson)
add_demo_subdirectory(poisson_matrix_free)
add_demo_subdirectory(hyperelasticity)
add_demo_subdirectory(interpolation-io)
add_demo_subdirectory(interpolation_different_meshes)

=== cpp/dolfinx/CMakeLists.txt ===
# ------------------------------------------------------------------------------
include(GNUInstallDirs)

# ------------------------------------------------------------------------------
# Declare the library (target) and set C++ standard
add_library(dolfinx)
target_compile_features(dolfinx PUBLIC cxx_std_20)

# ------------------------------------------------------------------------------
# Add source files to the target
set(DOLFINX_DIRS
    common
    fem
    geometry
    graph
    io
    la
    mesh
    nls
    refinement
)

# Add source to dolfinx target, and get sets of header files
foreach(DIR ${DOLFINX_DIRS})
  add_subdirectory(${DIR})
endforeach()

# Set target include location (for build and installed)
target_include_directories(
  dolfinx
  PUBLIC
    $<INSTALL_INTERFACE:include>
    "$<BUILD_INTERFACE:${DOLFINX_SOURCE_DIR};${DOLFINX_SOURCE_DIR}/dolfinx>"
)

# ------------------------------------------------------------------------------
# Configure the common/version.h file
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/common/version.h.in common/version.h @ONLY
)

# ------------------------------------------------------------------------------
# Set target properties
set_target_properties(
  dolfinx
  PROPERTIES VERSION ${DOLFINX_VERSION}
             SOVERSION ${DOLFINX_VERSION_MAJOR}.${DOLFINX_VERSION_MINOR}
)

# Add git revision flag to the one affected file
set_source_files_properties(
  common/defines.cpp
  PROPERTIES
    COMPILE_DEFINITIONS
    "UFCX_SIGNATURE=\"${UFCX_SIGNATURE}\";DOLFINX_GIT_COMMIT_HASH=\"${GIT_COMMIT_HASH}\""
)

# ------------------------------------------------------------------------------
# Set compiler options and definitions

# Set 'Developer' build type flags
target_compile_options(
  dolfinx PRIVATE $<$<CONFIG:Developer>:${DOLFINX_CXX_DEVELOPER_FLAGS}>
)

# Add version to definitions (public)
target_compile_definitions(dolfinx PUBLIC DOLFINX_VERSION="${DOLFINX_VERSION}")

# MSVC does not support the optional C99 _Complex type. Consequently, ufcx.h
# does not contain tabulate_tensor_complex* functions when built with MSVC. On
# MSVC this DOLFINX macro is set and this removes all calls to
# tabulate_tensor_complex*.
if(MSVC)
  target_compile_definitions(dolfinx PUBLIC DOLFINX_NO_STDC_COMPLEX_KERNELS)
endif()

# ------------------------------------------------------------------------------
# Add include directories and libraries of required packages

# pugixml (see https://pugixml.org/docs/manual.html#v1.11)
if(TARGET pugixml::pugixml)
  target_link_libraries(dolfinx PUBLIC pugixml::pugixml)
else()
  target_link_libraries(dolfinx PUBLIC pugixml)
endif()

# UFCx
if(TARGET ufcx::ufcx)
  target_link_libraries(dolfinx PUBLIC ufcx::ufcx)
else()
  target_include_directories(dolfinx SYSTEM PUBLIC ${UFCX_INCLUDE_DIRS})
endif()

# Basix
target_link_libraries(dolfinx PUBLIC Basix::basix)

# Boost
target_link_libraries(dolfinx PUBLIC Boost::headers)
target_link_libraries(dolfinx PUBLIC Boost::timer)

# MPI
target_link_libraries(dolfinx PUBLIC MPI::MPI_CXX)

target_link_libraries(dolfinx PUBLIC spdlog::spdlog)

# HDF5
target_link_libraries(dolfinx PUBLIC hdf5::hdf5)

# ------------------------------------------------------------------------------
# Optional packages

# ADIOS2
if(ADIOS2_FOUND)
  target_compile_definitions(dolfinx PUBLIC HAS_ADIOS2)
  target_link_libraries(dolfinx PUBLIC adios2::cxx11_mpi)
endif()

# PETSc
if(DOLFINX_ENABLE_PETSC AND PETSC_FOUND)
  target_link_libraries(dolfinx PUBLIC PkgConfig::PETSC)
  target_compile_definitions(dolfinx PUBLIC HAS_PETSC)
endif()

# SLEPC
if(DOLFINX_ENABLE_SLEPC AND SLEPC_FOUND)
  target_link_libraries(dolfinx PUBLIC PkgConfig::SLEPC)
  target_compile_definitions(dolfinx PUBLIC HAS_SLEPC)
endif()

# SCOTCH
if(DOLFINX_ENABLE_SCOTCH AND SCOTCH_FOUND)
  target_compile_definitions(dolfinx PUBLIC HAS_PTSCOTCH)
  target_link_libraries(dolfinx PRIVATE SCOTCH::ptscotch)
  if(TARGET SCOTCH::scotcherr)
    target_link_libraries(dolfinx PRIVATE SCOTCH::scotcherr)
  endif()
endif()

# ParMETIS
if(DOLFINX_ENABLE_PARMETIS AND PARMETIS_FOUND)
  target_compile_definitions(dolfinx PUBLIC HAS_PARMETIS)
  target_link_libraries(dolfinx PRIVATE ${PARMETIS_LIBRARIES})
  target_include_directories(dolfinx SYSTEM PRIVATE ${PARMETIS_INCLUDE_DIRS})
endif()

# KaHIP
if(DOLFINX_ENABLE_KAHIP AND KAHIP_FOUND)
  target_compile_definitions(dolfinx PUBLIC HAS_KAHIP)
  target_link_libraries(dolfinx PRIVATE ${KAHIP_LIBRARIES})
  target_include_directories(dolfinx SYSTEM PRIVATE ${KAHIP_INCLUDE_DIRS})
endif()

# ------------------------------------------------------------------------------
# Install dolfinx library and header files
if(WIN32)
  install(
    TARGETS dolfinx
    EXPORT DOLFINXTargets
    RUNTIME_DEPENDENCY_SET dependencies
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
  )

  if(INSTALL_RUNTIME_DEPENDENCIES)
    list(APPEND PRE_EXCLUDE_REGEXES "api-ms-.*")
    list(APPEND PRE_EXCLUDE_REGEXES "ext-ms-.*")
    install(
      RUNTIME_DEPENDENCY_SET
      dependencies
      DESTINATION
      ${CMAKE_INSTALL_BINDIR}
      PRE_EXCLUDE_REGEXES
      ${PRE_EXCLUDE_REGEXES}
      POST_EXCLUDE_REGEXES
      ".*system32/.*\\.dll"
      DIRECTORIES
      $<TARGET_FILE_DIR:Basix::basix>
    )
  endif()
else()
  install(
    TARGETS dolfinx
    EXPORT DOLFINXTargets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
  )
endif()

# Generate DOLFINTargets.cmake
install(EXPORT DOLFINXTargets DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/dolfinx)

# Install the header files
install(
  FILES dolfinx.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  COMPONENT Development
)

foreach(DIR ${DOLFINX_DIRS})
  install(
    FILES ${HEADERS_${DIR}}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dolfinx/${DIR}
    COMPONENT Development
  )
endforeach()

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/common/version.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dolfinx/common
  COMPONENT Development
)

# ------------------------------------------------------------------------------
# Generate CMake config files (DOLFINXConfig{,Version}.cmake)
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  ${CMAKE_BINARY_DIR}/dolfinx/DOLFINXConfigVersion.cmake
  VERSION ${DOLFINX_VERSION}
  COMPATIBILITY AnyNewerVersion
)

configure_package_config_file(
  ${DOLFINX_SOURCE_DIR}/cmake/templates/DOLFINXConfig.cmake.in
  ${CMAKE_BINARY_DIR}/dolfinx/DOLFINXConfig.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/dolfinx
)

# Install CMake helper files
install(
  FILES ${CMAKE_BINARY_DIR}/dolfinx/DOLFINXConfig.cmake
        ${CMAKE_BINARY_DIR}/dolfinx/DOLFINXConfigVersion.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/dolfinx
  COMPONENT Development
)

# ------------------------------------------------------------------------------
# Generate pkg-config file and install it

# Define packages that should be required by pkg-config file
set(PKG_REQUIRES "")

# Get link libraries and includes
get_target_property(
  PKGCONFIG_DOLFINX_TARGET_LINK_LIBRARIES dolfinx INTERFACE_LINK_LIBRARIES
)
get_target_property(
  PKGCONFIG_DOLFINX_INCLUDE_DIRECTORIES dolfinx
  INTERFACE_SYSTEM_INCLUDE_DIRECTORIES
)

# Add imported targets to lists for creating pkg-config file
set(PKGCONFIG_DOLFINX_LIBS)

foreach(_target ${PKGCONFIG_DOLFINX_TARGET_LINK_LIBRARIES})
  if("${_target}" MATCHES "^[^<>]+$") # Skip "$<foo...>", which we get with
                                      # static libs
    if("${_target}" MATCHES "^.*::.*$")
      # Get include paths
      get_target_property(_inc_dirs ${_target} INTERFACE_INCLUDE_DIRECTORIES)

      if(_inc_dirs)
        list(APPEND PKGCONFIG_DOLFINX_INCLUDE_DIRECTORIES ${_inc_dirs})
      endif()

      # Get libraries
      get_target_property(_libs ${_target} INTERFACE_LINK_LIBRARIES)

      if(_libs)
        list(APPEND PKGCONFIG_DOLFINX_LIBS ${_libs})
      endif()

    else()
      # 'regular' libs, i.e. not imported targets
      list(APPEND PKGCONFIG_DOLFINX_LIBS ${_target})
    endif()

    # Special handling to extract data for compiled Boost imported
    # targets to use in generate pkg-config file
    if(("${_target}" MATCHES "^.*Boost::.*$") AND NOT "${_target}" STREQUAL
                                                  "Boost::headers"
    )
      get_target_property(_libs ${_target} IMPORTED_LOCATION_RELEASE)

      if(_libs)
        list(APPEND PKGCONFIG_DOLFINX_LIBS ${_libs})
      endif()
    endif()
  endif()
endforeach()

# Join include lists and remove duplicates
list(REMOVE_DUPLICATES PKGCONFIG_DOLFINX_INCLUDE_DIRECTORIES)
list(REMOVE_DUPLICATES PKGCONFIG_DOLFINX_LIBS)

# Convert include dirs to -I<incdir> form
foreach(_inc_dir ${PKGCONFIG_DOLFINX_INCLUDE_DIRECTORIES})
  set(PKG_INCLUDES "-I${_inc_dir} ${PKG_INCLUDES}")
endforeach()

# Get dolfinx definitions
get_target_property(
  PKG_DOLFINX_DEFINITIONS dolfinx INTERFACE_COMPILE_DEFINITIONS
)
set(PKG_DEFINITIONS)

foreach(_def ${PKG_DOLFINX_DEFINITIONS})
  set(PKG_DEFINITIONS "${PKG_DEFINITIONS} -D${_def}")
endforeach()

# Get basix definitions (this is required to propagate Basix definition to the
# pkg-config file, in the future Basix should create its own basix.pc file, see
# https://github.com/FEniCS/basix/issues/204)
get_target_property(
  PKG_BASIX_DEFINITIONS Basix::basix INTERFACE_COMPILE_DEFINITIONS
)

foreach(_def ${PKG_BASIX_DEFINITIONS})
  set(PKG_DEFINITIONS "${PKG_DEFINITIONS} -D${_def}")
endforeach()

# Convert compiler flags and definitions into space separated strings
string(REPLACE ";" " " PKG_CXXFLAGS "${CMAKE_CXX_FLAGS}")
string(REPLACE ";" " " PKG_LINKFLAGS "${CMAKE_EXE_LINKER_FLAGS}")

# Convert libraries to -L<libdir> -l<lib> form
foreach(_lib ${PKGCONFIG_DOLFINX_LIBS})
  # Add -Wl,option directives
  if("${_lib}" MATCHES "-Wl,[^ ]*")
    set(PKG_LINKFLAGS "${_lib} ${PKG_LINKFLAGS}")
  else()
    get_filename_component(_path ${_lib} DIRECTORY)
    get_filename_component(_name ${_lib} NAME_WE)
    string(REPLACE "lib" "" _name "${_name}")

    # Add libraries that matches the form -L<libdir> -l<lib>
    if(NOT "${_path}" STREQUAL "")
      set(PKG_LINKFLAGS "-L${_path} -l${_name} ${PKG_LINKFLAGS}")
    endif()
  endif()
endforeach()

# Remove duplicated link flags
separate_arguments(PKG_LINKFLAGS)
list(REMOVE_DUPLICATES PKG_LINKFLAGS)
string(REPLACE ";" " " PKG_LINKFLAGS "${PKG_LINKFLAGS}")

# Add additional link flags
foreach(_linkflag ${DOLFINX_LINK_FLAGS})
  set(PKG_LINKFLAGS "${PKG_LINKFLAGS} ${_linkflag}")
endforeach()

# Boost include dir (used as pkg-config variable)
get_target_property(
  BOOST_INCLUDE_DIR Boost::headers INTERFACE_INCLUDE_DIRECTORIES
)

# Configure and install pkg-config file
configure_file(
  ${DOLFINX_SOURCE_DIR}/cmake/templates/dolfinx.pc.in
  ${CMAKE_BINARY_DIR}/dolfinx.pc @ONLY
)
install(
  FILES ${CMAKE_BINARY_DIR}/dolfinx.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  COMPONENT Development
)

# ------------------------------------------------------------------------------

=== cpp/test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(dolfinx-tests)

project(${PROJECT_NAME} LANGUAGES C CXX)
set(CMAKE_C_STANDARD 17) # For FFCx generated .c files.
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Find DOLFINx config file
find_package(DOLFINX REQUIRED)

add_custom_command(
  OUTPUT poisson.c
  COMMAND ffcx ${CMAKE_CURRENT_SOURCE_DIR}/poisson.py
  VERBATIM
  DEPENDS poisson.py
  COMMENT "Compile poisson.py using FFCx"
)

find_package(Catch2 3)

if(NOT Catch2_FOUND)
  message(STATUS "Catch2 not found. Downloading.")
  include(FetchContent)
  FetchContent_Declare(
    Catch2
    GIT_REPOSITORY https://github.com/catchorg/Catch2.git
    GIT_TAG v3.4.0
  )
  FetchContent_MakeAvailable(Catch2)
endif()

add_executable(
  unittests
  main.cpp
  vector.cpp
  matrix.cpp
  io.cpp
  common/sub_systems_manager.cpp
  common/index_map.cpp
  common/sort.cpp
  fem/functionspace.cpp
  mesh/distributed_mesh.cpp
  mesh/generation.cpp
  common/CIFailure.cpp
  mesh/refinement/interval.cpp
  mesh/refinement/option.cpp
  mesh/refinement/rectangle.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/poisson.c
)
target_link_libraries(unittests PRIVATE Catch2::Catch2WithMain dolfinx)
# UUID requires bcrypt to be linked on Windows, broken in vcpkg.
# https://github.com/microsoft/vcpkg/issues/4481
if(WIN32)
  target_link_libraries(unittests PRIVATE bcrypt)
endif()
target_include_directories(
  unittests PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
)

# Add some strict compiler checks only on C++ part (Developer).
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-Wall -Werror -Wextra -pedantic" HAVE_PEDANTIC)

if(HAVE_PEDANTIC)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -Wall;-Werror;-Wextra;-pedantic)
endif()

target_compile_options(
  unittests
  PRIVATE
    $<$<AND:$<CONFIG:Developer>,$<COMPILE_LANGUAGE:CXX>>:${DOLFINX_CXX_DEVELOPER_FLAGS}>
)

# Enable testing
enable_testing()

# Test target
add_test(unittests unittests)

=== cpp/demo/biharmonic/CMakeLists.txt ===
# This file was generated by running
#
# python cmake/scripts/generate-cmakefiles from dolfinx/cpp
#
cmake_minimum_required(VERSION 3.19)

set(PROJECT_NAME demo_biharmonic)
project(${PROJECT_NAME} LANGUAGES C CXX)

# Set C++20 standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT TARGET dolfinx)
  find_package(DOLFINX REQUIRED)
endif()

include(CheckSymbolExists)
set(CMAKE_REQUIRED_INCLUDES ${PETSC_INCLUDE_DIRS})
check_symbol_exists(PETSC_USE_COMPLEX petscsystypes.h PETSC_SCALAR_COMPLEX)
check_symbol_exists(PETSC_USE_REAL_DOUBLE petscsystypes.h PETSC_REAL_DOUBLE)

# Add target to compile UFL files
if(PETSC_SCALAR_COMPLEX EQUAL 1)
  if(PETSC_REAL_DOUBLE EQUAL 1)
    set(SCALAR_TYPE "--scalar_type=complex128")
  else()
    set(SCALAR_TYPE "--scalar_type=complex64")
  endif()
else()
  if(PETSC_REAL_DOUBLE EQUAL 1)
    set(SCALAR_TYPE "--scalar_type=float64")
  else()
    set(SCALAR_TYPE "--scalar_type=float32")
  endif()
endif()
add_custom_command(
  OUTPUT biharmonic.c
  COMMAND ffcx ${CMAKE_CURRENT_SOURCE_DIR}/biharmonic.py ${SCALAR_TYPE}
  VERBATIM
  DEPENDS biharmonic.py
  COMMENT "Compile biharmonic.py using FFCx"
)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_executable(${PROJECT_NAME} main.cpp ${CMAKE_CURRENT_BINARY_DIR}/biharmonic.c)
target_link_libraries(${PROJECT_NAME} dolfinx)

# Do not throw error for 'multi-line comments' (these are typical in rst which
# includes LaTeX)
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-Wno-comment" HAVE_NO_MULTLINE)
set_source_files_properties(
  main.cpp
  PROPERTIES
    COMPILE_FLAGS
    "$<$<BOOL:${HAVE_NO_MULTLINE}>:-Wno-comment -Wall -Wextra -pedantic -Werror>"
)

# Test targets (used by DOLFINx testing system)
set(TEST_PARAMETERS2 -np 2 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
set(TEST_PARAMETERS3 -np 3 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
add_test(NAME ${PROJECT_NAME}_mpi_2 COMMAND "mpirun" ${TEST_PARAMETERS2})
add_test(NAME ${PROJECT_NAME}_mpi_3 COMMAND "mpirun" ${TEST_PARAMETERS3})
add_test(NAME ${PROJECT_NAME}_serial COMMAND ${PROJECT_NAME})

=== cpp/demo/codim_0_assembly/CMakeLists.txt ===
# This file was generated by running
#
# python cmake/scripts/generate-cmakefiles from dolfinx/cpp
#
cmake_minimum_required(VERSION 3.19)

set(PROJECT_NAME demo_codim_0_assembly)
project(${PROJECT_NAME} LANGUAGES C CXX)

# Set C++20 standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT TARGET dolfinx)
  find_package(DOLFINX REQUIRED)
endif()

include(CheckSymbolExists)
set(CMAKE_REQUIRED_INCLUDES ${PETSC_INCLUDE_DIRS})
check_symbol_exists(PETSC_USE_COMPLEX petscsystypes.h PETSC_SCALAR_COMPLEX)
check_symbol_exists(PETSC_USE_REAL_DOUBLE petscsystypes.h PETSC_REAL_DOUBLE)

# Add target to compile UFL files
if(PETSC_SCALAR_COMPLEX EQUAL 1)
  if(PETSC_REAL_DOUBLE EQUAL 1)
    set(SCALAR_TYPE "--scalar_type=complex128")
  else()
    set(SCALAR_TYPE "--scalar_type=complex64")
  endif()
else()
  if(PETSC_REAL_DOUBLE EQUAL 1)
    set(SCALAR_TYPE "--scalar_type=float64")
  else()
    set(SCALAR_TYPE "--scalar_type=float32")
  endif()
endif()
add_custom_command(
  OUTPUT mixed_codim0.c
  COMMAND ffcx ${CMAKE_CURRENT_SOURCE_DIR}/mixed_codim0.py ${SCALAR_TYPE}
  VERBATIM
  DEPENDS mixed_codim0.py
  COMMENT "Compile mixed_codim0.py using FFCx"
)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_executable(${PROJECT_NAME} main.cpp ${CMAKE_CURRENT_BINARY_DIR}/mixed_codim0.c)
target_link_libraries(${PROJECT_NAME} dolfinx)

# Do not throw error for 'multi-line comments' (these are typical in rst which
# includes LaTeX)
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-Wno-comment" HAVE_NO_MULTLINE)
set_source_files_properties(
  main.cpp
  PROPERTIES
    COMPILE_FLAGS
    "$<$<BOOL:${HAVE_NO_MULTLINE}>:-Wno-comment -Wall -Wextra -pedantic -Werror>"
)

# Test targets (used by DOLFINx testing system)
set(TEST_PARAMETERS2 -np 2 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
set(TEST_PARAMETERS3 -np 3 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
add_test(NAME ${PROJECT_NAME}_mpi_2 COMMAND "mpirun" ${TEST_PARAMETERS2})
add_test(NAME ${PROJECT_NAME}_mpi_3 COMMAND "mpirun" ${TEST_PARAMETERS3})
add_test(NAME ${PROJECT_NAME}_serial COMMAND ${PROJECT_NAME})

=== cpp/demo/custom_kernel/CMakeLists.txt ===
# This file was generated by running
#
# python cmake/scripts/generate-cmakefiles.py from dolfinx/cpp
#
cmake_minimum_required(VERSION 3.19)

set(PROJECT_NAME demo_custom_kernel)
project(${PROJECT_NAME} LANGUAGES C CXX)

# Set C++20 standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT TARGET dolfinx)
  find_package(DOLFINX REQUIRED)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_executable(${PROJECT_NAME} main.cpp)
target_link_libraries(${PROJECT_NAME} dolfinx)

# Do not throw error for 'multi-line comments' (these are typical in rst which
# includes LaTeX)
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-Wno-comment" HAVE_NO_MULTLINE)
set_source_files_properties(
  main.cpp
  PROPERTIES
    COMPILE_FLAGS
    "$<$<BOOL:${HAVE_NO_MULTLINE}>:-Wno-comment -Wall -Wextra -pedantic -Werror>"
)

# Test targets (used by DOLFINx testing system)
set(TEST_PARAMETERS2 -np 2 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
set(TEST_PARAMETERS3 -np 3 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
add_test(NAME ${PROJECT_NAME}_mpi_2 COMMAND "mpirun" ${TEST_PARAMETERS2})
add_test(NAME ${PROJECT_NAME}_mpi_3 COMMAND "mpirun" ${TEST_PARAMETERS3})
add_test(NAME ${PROJECT_NAME}_serial COMMAND ${PROJECT_NAME})

=== cpp/demo/hyperelasticity/CMakeLists.txt ===
# This file was generated by running
#
# python cmake/scripts/generate-cmakefiles from dolfinx/cpp
#
cmake_minimum_required(VERSION 3.19)

set(PROJECT_NAME demo_hyperelasticity)
project(${PROJECT_NAME} LANGUAGES C CXX)

# Set C++20 standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT TARGET dolfinx)
  find_package(DOLFINX REQUIRED)
endif()

include(CheckSymbolExists)
set(CMAKE_REQUIRED_INCLUDES ${PETSC_INCLUDE_DIRS})
check_symbol_exists(PETSC_USE_COMPLEX petscsystypes.h PETSC_SCALAR_COMPLEX)
if(PETSC_SCALAR_COMPLEX EQUAL 1)
  message(STATUS "** This demo does not support complex mode")
else()
  check_symbol_exists(PETSC_USE_REAL_DOUBLE petscsystypes.h PETSC_REAL_DOUBLE)
  if(PETSC_REAL_DOUBLE EQUAL 1)
    set(SCALAR_TYPE "--scalar_type=float64")
  else()
    set(SCALAR_TYPE "--scalar_type=float32")
  endif()

  # Add target to compile UFL files
  add_custom_command(
    OUTPUT hyperelasticity.c
    COMMAND ffcx ${CMAKE_CURRENT_SOURCE_DIR}/hyperelasticity.py ${SCALAR_TYPE}
    VERBATIM
    DEPENDS hyperelasticity.py
    COMMENT "Compile hyperelasticity.py using FFCx"
  )

  set(CMAKE_INCLUDE_CURRENT_DIR ON)

  add_executable(${PROJECT_NAME} main.cpp ${CMAKE_CURRENT_BINARY_DIR}/hyperelasticity.c)
  target_link_libraries(${PROJECT_NAME} dolfinx)

  # Do not throw error for 'multi-line comments' (these are typical in rst which
  # includes LaTeX)
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag("-Wno-comment" HAVE_NO_MULTLINE)
  set_source_files_properties(
    main.cpp
    PROPERTIES
      COMPILE_FLAGS
      "$<$<BOOL:${HAVE_NO_MULTLINE}>:-Wno-comment -Wall -Wextra -pedantic -Werror>"
  )

  # Test targets (used by DOLFINx testing system)
  set(TEST_PARAMETERS2 -np 2 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
  set(TEST_PARAMETERS3 -np 3 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
  add_test(NAME ${PROJECT_NAME}_mpi_2 COMMAND "mpirun" ${TEST_PARAMETERS2})
  add_test(NAME ${PROJECT_NAME}_mpi_3 COMMAND "mpirun" ${TEST_PARAMETERS3})
  add_test(NAME ${PROJECT_NAME}_serial COMMAND ${PROJECT_NAME})
endif()

=== cpp/demo/interpolation-io/CMakeLists.txt ===
# This file was generated by running
#
# python cmake/scripts/generate-cmakefiles.py from dolfinx/cpp
#
cmake_minimum_required(VERSION 3.19)

set(PROJECT_NAME demo_interpolation-io)
project(${PROJECT_NAME} LANGUAGES C CXX)

# Set C++20 standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT TARGET dolfinx)
  find_package(DOLFINX REQUIRED)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_executable(${PROJECT_NAME} main.cpp)
target_link_libraries(${PROJECT_NAME} dolfinx)

# Do not throw error for 'multi-line comments' (these are typical in rst which
# includes LaTeX)
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-Wno-comment" HAVE_NO_MULTLINE)
set_source_files_properties(
  main.cpp
  PROPERTIES
    COMPILE_FLAGS
    "$<$<BOOL:${HAVE_NO_MULTLINE}>:-Wno-comment -Wall -Wextra -pedantic -Werror>"
)

# Test targets (used by DOLFINx testing system)
set(TEST_PARAMETERS2 -np 2 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
set(TEST_PARAMETERS3 -np 3 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
add_test(NAME ${PROJECT_NAME}_mpi_2 COMMAND "mpirun" ${TEST_PARAMETERS2})
add_test(NAME ${PROJECT_NAME}_mpi_3 COMMAND "mpirun" ${TEST_PARAMETERS3})
add_test(NAME ${PROJECT_NAME}_serial COMMAND ${PROJECT_NAME})

=== cpp/demo/interpolation_different_meshes/CMakeLists.txt ===
# This file was generated by running
#
# python cmake/scripts/generate-cmakefiles.py from dolfinx/cpp
#
cmake_minimum_required(VERSION 3.19)

set(PROJECT_NAME demo_interpolation_different_meshes)
project(${PROJECT_NAME} LANGUAGES C CXX)

# Set C++20 standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT TARGET dolfinx)
  find_package(DOLFINX REQUIRED)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_executable(${PROJECT_NAME} main.cpp)
target_link_libraries(${PROJECT_NAME} dolfinx)

# Do not throw error for 'multi-line comments' (these are typical in rst which
# includes LaTeX)
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-Wno-comment" HAVE_NO_MULTLINE)
set_source_files_properties(
  main.cpp
  PROPERTIES
    COMPILE_FLAGS
    "$<$<BOOL:${HAVE_NO_MULTLINE}>:-Wno-comment -Wall -Wextra -pedantic -Werror>"
)

# Test targets (used by DOLFINx testing system)
set(TEST_PARAMETERS2 -np 2 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
set(TEST_PARAMETERS3 -np 3 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
add_test(NAME ${PROJECT_NAME}_mpi_2 COMMAND "mpirun" ${TEST_PARAMETERS2})
add_test(NAME ${PROJECT_NAME}_mpi_3 COMMAND "mpirun" ${TEST_PARAMETERS3})
add_test(NAME ${PROJECT_NAME}_serial COMMAND ${PROJECT_NAME})

=== cpp/demo/poisson/CMakeLists.txt ===
# This file was generated by running
#
# python cmake/scripts/generate-cmakefiles from dolfinx/cpp
#
cmake_minimum_required(VERSION 3.19)

set(PROJECT_NAME demo_poisson)
project(${PROJECT_NAME} LANGUAGES C CXX)

# Set C++20 standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT TARGET dolfinx)
  find_package(DOLFINX REQUIRED)
endif()

include(CheckSymbolExists)
set(CMAKE_REQUIRED_INCLUDES ${PETSC_INCLUDE_DIRS})
check_symbol_exists(PETSC_USE_COMPLEX petscsystypes.h PETSC_SCALAR_COMPLEX)
check_symbol_exists(PETSC_USE_REAL_DOUBLE petscsystypes.h PETSC_REAL_DOUBLE)

# Add target to compile UFL files
if(PETSC_SCALAR_COMPLEX EQUAL 1)
  if(PETSC_REAL_DOUBLE EQUAL 1)
    set(SCALAR_TYPE "--scalar_type=complex128")
  else()
    set(SCALAR_TYPE "--scalar_type=complex64")
  endif()
else()
  if(PETSC_REAL_DOUBLE EQUAL 1)
    set(SCALAR_TYPE "--scalar_type=float64")
  else()
    set(SCALAR_TYPE "--scalar_type=float32")
  endif()
endif()
add_custom_command(
  OUTPUT poisson.c
  COMMAND ffcx ${CMAKE_CURRENT_SOURCE_DIR}/poisson.py ${SCALAR_TYPE}
  VERBATIM
  DEPENDS poisson.py
  COMMENT "Compile poisson.py using FFCx"
)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_executable(${PROJECT_NAME} main.cpp ${CMAKE_CURRENT_BINARY_DIR}/poisson.c)
target_link_libraries(${PROJECT_NAME} dolfinx)

# Do not throw error for 'multi-line comments' (these are typical in rst which
# includes LaTeX)
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-Wno-comment" HAVE_NO_MULTLINE)
set_source_files_properties(
  main.cpp
  PROPERTIES
    COMPILE_FLAGS
    "$<$<BOOL:${HAVE_NO_MULTLINE}>:-Wno-comment -Wall -Wextra -pedantic -Werror>"
)

# Test targets (used by DOLFINx testing system)
set(TEST_PARAMETERS2 -np 2 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
set(TEST_PARAMETERS3 -np 3 ${MPIEXEC_PARAMS} "./${PROJECT_NAME}")
add_test(NAME ${PROJECT_NAME}_mpi_2 COMMAND "mpirun" ${TEST_PARAMETERS2})
add_test(NAME ${PROJECT_NAME}_mpi_3 COMMAND "mpirun" ${TEST_PARAMETERS3})
add_test(NAME ${PROJECT_NAME}_serial COMMAND ${PROJECT_NAME})

=== debian/changelog ===
fenics-dolfinx (1:0.9.0-10) unstable; urgency=medium

  * debian patch gjk_multiprecision_PR3770.diff applies upstream
    PR#3770 to make compute_distance_gjk more robust by using
    boost multiprecision. Remove gjk test skips.
    Needed for scipy 1.16.

 -- Drew Parsons <dparsons@debian.org>  Mon, 13 Oct 2025 14:50:03 +0200

fenics-dolfinx (1:0.9.0-9) unstable; urgency=medium

  * python3-dolfinx-real, python3-dolfinx-complex
    Breaks: python3-basix (<< 0.9.0-4~)
    to manage breakage from old packages built against
    old nanobind 2.5 (abi15)

 -- Drew Parsons <dparsons@debian.org>  Thu, 09 Oct 2025 11:56:32 +0200

fenics-dolfinx (1:0.9.0-8) unstable; urgency=medium

  * add alpha to the arch list skipping test_cube_distance (test_gjk)
  * debian patch python_depends_nanobind.patch injects nanobind into
    python depends (pyproject.toml) to enable dh_python3 to catch the
    nanobind ABI. Drop explicit Depends: python-nanobind from
    debian/control for python-dolfinx-{real,complex}. Closes: #1096624.
  * Build-Depends: python3-numpy-dev (for dh_numpy3)
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Thu, 11 Sep 2025 12:54:08 +0200

fenics-dolfinx (1:0.9.0-7) unstable; urgency=medium

  * Change capture mode and verbosity in pusimp tests: drop -s, and decrease the
    verbosity from -vv to -v. Closes: #1101505.
  * Export MPLBACKEND=agg before running sphinx. See Bug: #1101565.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 29 Mar 2025 15:17:31 +0000

fenics-dolfinx (1:0.9.0-6) unstable; urgency=medium

  * Build-Depends: python3-gmsh to run gmshio unit tests at build time.
    Hence drop from debian/tests Depends (pulled via @builddeps@)
  * python-dolfinx Recommends: python3-gmsh.
    dolfinx does not need to use gmshio, but a standard installation
    can be expected to have it available.
  * drop unused Depends: python3-ply, python3-sympy

 -- Drew Parsons <dparsons@debian.org>  Sun, 29 Dec 2024 18:02:28 +0100

fenics-dolfinx (1:0.9.0-5) unstable; urgency=medium

  * skip test_compare_solvers on ppc64 same as mips64el
  * debian/tests: skip demo_hdg in demo tests.
    It is very slow (even when it passes) and causes time-out failures.

 -- Drew Parsons <dparsons@debian.org>  Mon, 02 Dec 2024 16:55:08 +0100

fenics-dolfinx (1:0.9.0-4) unstable; urgency=medium

  * dolfinx-doc Recommends: python3-pyvista
    (many demos use pyvista for demo visualisation)
  * skip test_compare_solvers on mips64el. Newton iterations fail to
    pass tolerance in test_petsc_solver_wrappers.py
    TestPETScSolverWrappers.test_compare_solvers. Closes: #1088345.
  * drop Build-Depends: python3-pkg-resources (no longer used).
    Closes: #1083391.

 -- Drew Parsons <dparsons@debian.org>  Sun, 01 Dec 2024 11:19:33 +0100

fenics-dolfinx (1:0.9.0-3) unstable; urgency=medium

  * Add unpin_cffi.patch:
    - upstream pins cffi version to 1.16 due to
      https://github.com/FEniCS/dolfinx/issues/3340
      which causes demo_static-condensation.py to fail to run in complex mode.
    - debian cffi version is already beyond 1.16 (currently 1.17), so we cannot
      satisfy the pin in any case. The demo is skipped anyways on debci, because
      it requires numba.
    - pybuild effectively ignores the pin, but leaving it in pyproject.toml
      results in an inconsistency between the actual debian installation and the
      python package metadata.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Thu, 14 Nov 2024 12:21:16 +0000

fenics-dolfinx (1:0.9.0-2) unstable; urgency=medium

  * Upload to unstable

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 09 Nov 2024 07:55:06 +0000

fenics-dolfinx (1:0.9.0-1exp5) experimental; urgency=medium

  * Add epoch in versioned depends for python3-dolfinx:
     python3-dolfinx-real (>= 1:0.9.0~) | python3-dolfinx-complex (>= 1:0.9.0~)

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Thu, 07 Nov 2024 07:54:15 +0000

fenics-dolfinx (1:0.9.0-1exp4) experimental; urgency=medium

  * Set versioned depends for python3-dolfinx:
      python3-dolfinx-real (>= 0.9.0~) | python3-dolfinx-complex (>= 0.9.0~)

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Tue, 05 Nov 2024 12:01:11 +0000

fenics-dolfinx (1:0.9.0-1exp3) experimental; urgency=medium

  * Add libspdlog-dev to libdolfinx-dev Depends, since dolfinx header files
    include spdlog ones.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 03 Nov 2024 13:22:20 +0000

fenics-dolfinx (1:0.9.0-1exp2) experimental; urgency=medium

  * Add test_adios2_skip.patch to skip some tests in
    python/test/unit/io/test_adios2.py if dolfinx was built without support for
    ADIOS2. This typically happens on 32 bit arches.
  * test/unit/geometry/test_gjk.py::test_cube_distance currently fails on i386
    as well. Add i386 to the list of arches on which the test must be skipped.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 02 Nov 2024 15:28:38 +0000

fenics-dolfinx (1:0.9.0-1exp1) experimental; urgency=medium

  * New upstream release 0.9.0:
    - new ABI 0.9
  * Build-Depends and Depends on FEniCSx components part of release 0.9.0.
  * Refresh patches
    - extra_CXXFLAGS.patch
    - python_cmake_module_path.patch
    - lib_rename.patch
    - python_unit_test_32bit.patch
    - docs_local_mathjax.patch
    - debian_version_id.patch
    - adios_config_mpi.patch
    - python_local_license.patch
    - pusimp.patch
    so that they apply without fuzz.
  * Refresh patches
    - big_endian_skip_adios2_tests.patch
    so that they apply without failing on the new release.
  * Refresh demo_no_vtk_adios2.patch as follows:
    - it is not necessary anymore to patch demo_pml.py, since upstream has added
      a check that forces the demo to be skipped if adios2 is not installed.
    - refresh filenames for demo_scattering_boundary_conditions.py and
      demo_half_loaded_waveguide.py since upstream moved them to the main demo


=== debian/control ===
Source: fenics-dolfinx
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Francesco Ballarin <francesco.ballarin@unicatt.it>
Section: math
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               gfortran,
               catch2 (>= 3~),
               chrpath,
               libbasix-dev (>= 0.9.0~),
               python3-basix,
               libboost-chrono-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-math-dev,
               libboost-mpi-dev,
               libboost-program-options-dev,
               libboost-serialization-dev,
               libboost-thread-dev,
               libboost-timer-dev,
               libeigen3-dev,
               libhdf5-mpi-dev,
               libadios2-mpi-c++11-dev [amd64 arm64 mips64el ppc64el riscv64 s390x loong64 ppc64 sparc64],
               libpugixml-dev,
               libsuitesparse-dev,
               libscotch-dev,
               libxml2-dev,
               mpi-default-dev,
               libpetsc-real-dev,
               libpetsc-complex-dev,
               libslepc-real-dev,
               libslepc-complex-dev,
               python3-setuptools,
               pybuild-plugin-pyproject,
               python3-petsc4py,
               python3-petsc4py-real,
               python3-petsc4py-complex,
               python3-slepc4py,
               python3-slepc4py-real,
               python3-slepc4py-complex,
               pkgconf,
               python3-all-dev,
               python3-cffi,
               python3-ffcx (>= 1:0.9.0~),
               python3-ffcx (<< 1:0.10.0),
               python3-gmsh,
               python3-ufl (>= 2024.2.0~),
               python3-mpi4py,
               python3-nanobind (>= 2.0.0~),
               python3-numpy (>= 1:1.21~),
               python3-numpy-dev,
               python3-pip,
               python3-pytest <!nocheck>,
               python3-pusimp (>= 0.1.1~),
               python3-requests <!nocheck>,
               python3-scikit-build-core,
               python3-scipy <!nocheck>,
               python3-sphinx,
               python3-virtualenv,
               libspdlog-dev
Build-Depends-Indep: doxygen,
                     graphviz,
                     libjs-mathjax,
                     libjs-modernizr,
                     python3-jupytext,
                     python3-matplotlib,
                     python3-myst-parser,
                     python3-sphinx-rtd-theme
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/fenics/fenics-dolfinx
Vcs-Git: https://salsa.debian.org/science-team/fenics/fenics-dolfinx.git
Homepage: https://fenicsproject.org
Rules-Requires-Root: no

Package: libdolfinx-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdolfinx-real-dev (>= ${source:Version}) | libdolfinx-complex-dev (>= ${source:Version}),
         libdolfinx-real-dev (<< ${dolfinx:Next-Upstream-Version}) | libdolfinx-complex-dev (<< ${dolfinx:Next-Upstream-Version}),
         cmake,
         g++ | c++-compiler,
         libboost-chrono-dev,
         libboost-dev,
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-math-dev,
         libboost-mpi-dev,
         libboost-program-options-dev,
         libboost-serialization-dev,
         libboost-thread-dev,
         libboost-timer-dev,
         libeigen3-dev,
         libhdf5-mpi-dev,
         libadios2-mpi-c++11-dev [amd64 arm64 mips64el ppc64el riscv64 s390x loong64 ppc64 sparc64],
         libpugixml-dev,
         libsuitesparse-dev,
         libscotch-dev,
         libspdlog-dev,
         libxml2-dev,
         pkgconf,
         python3-ffcx (>= 1:0.9.0~),
         python3-ffcx (<< 1:0.10.0),
         ${misc:Depends}
Description: Shared links and header files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the common development files and depends on
 the real or complex development package.
 .
 This is the next-generation version of libdolfinx-dev (DOLFIN-X).
 The legacy version of DOLFIN is provided by libdolfin-dev.

Package: libdolfinx-real-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdolfinx-real0.9 (= ${binary:Version}),
         ${petsc:Depends},
         ${misc:Depends}
Recommends: libdolfinx-dev
Description: Shared links and header files for DOLFIN (real numbers)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files for the real number build.
 .
 This is the next-generation version of DOLFIN-X.
 The legacy version of DOLFIN is provided by libdolfin-dev.

Package: libdolfinx-complex-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdolfinx-complex0.9 (= ${binary:Version}),
         ${petsc-complex:Depends},
         ${misc:Depends}
Recommends: libdolfinx-dev
Description: Shared links and header files for DOLFIN (complex numbers)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files for the complex number build.
 .
 This is the next-generation version of DOLFIN-).
 The legacy version of DOLFIN is provided by libdolfin-dev.

Package: libdolfinx-real0.9
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: dolfinx-doc,
          python3-dolfinx
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries with real number support.

Package: libdolfinx-complex0.9
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: dolfinx-doc,
          python3-dolfinx
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries with complex number support.

Package: python3-dolfinx
Architecture: any
Multi-Arch: same
Section: python
Depends: python3-dolfinx-real (>= 1:0.9.0~) | python3-dolfinx-complex (>= 1:0.9.0~),
         python3:any,
         ${misc:Depends},
         ${python3:Depends}
Recommends: python3-gmsh
Suggests: dolfinx-doc
Breaks: python3-dolfinx-mpc (<< 0.8.0.post1-5)
Description: Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This is the next-generation version of libdolfinx-dev (DOLFIN-X).
 The legacy version of DOLFIN is provided by python3-dolfin.
 .
 This is a base package depending on the dolfinx packages with
 real or complex number support. By default the version built against
 the preferred version of PETSc in /usr/lib/petsc is selected, but the
 alternative version can be selected by setting the environment
 variable PETSC_DIR.

Package: python3-dolfinx-real
Architecture: any
Section: python
Depends: libdolfinx-dev (= ${binary:Version}),
         libdolfinx-real-dev (= ${binary:Version}),
         python3-ffcx (>= 1:0.9.0~),
         python3-ffcx (<< 1:0.10.0),
         python3-ufl (>= 2024.2.0~),
         python3-cffi,
         python3-mpi4py,
         python3-numpy (>= 1:1.21~),
         python3-pusimp (>= 0.1.1~),
         python3-scipy,
         ${python3-petsc4py-real:Depends},
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-dolfinx
Suggests: dolfinx-doc
Breaks: python3-basix (<< 0.9.0-4~)
Description: Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 3).
 .
 This is the next-generation version of libdolfinx-dev (DOLFIN-X).
 The legacy version of DOLFIN is provided by python3-dolfin.

Package: python3-dolfinx-complex
Architecture: any
Section: python
Depends: libdolfinx-dev (= ${binary:Version}),
         libdolfinx-complex-dev (= ${binary:Version}),
         python3-ffcx (>= 1:0.9.0~),
         python3-ffcx (<< 1:0.10.0),
         python3-ufl (>= 2024.2.0~),
         python3-cffi,
         python3-mpi4py,
         python3-numpy,
         python3-pusimp (>= 0.1.1~),
         python3-scipy,
         ${python3-petsc4py-complex:Depends},
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-dolfinx
Suggests: dolfinx-doc
Breaks: python3-basix (<< 0.9.0-4~)
Description: Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/architecture.mk

OS_ID := $(shell grep -E "^ID" /etc/os-release | sed "s/^ID=//")

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_EPOCH := $(shell echo $(DEB_VERSION) | cut -d: -f1)
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

DEBIAN_VERSION_ID := $(OS_ID)_$(DEB_VERSION)

DOLFINX_RELEASE_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)
DOLFINX_MAJOR_VERSION=$(shell echo $(DOLFINX_RELEASE_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
DOLFINX_MINOR_VERSION=$(shell echo $(DOLFINX_RELEASE_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
DOLFINX_VERSION=$(DOLFINX_MAJOR_VERSION).$(DOLFINX_MINOR_VERSION)
DOLFINX_NEXT_VERSION=$(DEB_EPOCH):$(DOLFINX_MAJOR_VERSION).$(shell echo $$(( $(DOLFINX_MINOR_VERSION) + 1 )) )

# Allow test programs that use OpenMPI to run
export PRTE_MCA_plm_ssh_agent=/bin/false
export OMPI_MCA_btl_base_warn_component_unused=0

include /usr/share/mpi-default-dev/debian_defaults
ENABLE_MPI=ON
ifeq ($(findstring $(DEB_BUILD_ARCH),$(OPENMPI_ARCHITECTURES)),)
MPIEXEC_PARAMS=
else
MPIEXEC_PARAMS=--oversubscribe
endif

DOLFINX_HOME = $(CURDIR)/$(DEB_SRCDIR)
USCAN_DESTDIR := $(CURDIR)
PY3VER_DEFAULT := $(shell py3versions -dv)

BUILDDIR_REAL = $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)-real
BUILDDIR_COMPLEX = $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)-complex

NPROC := $(shell nproc)
PARALLEL = $(subst parallel=,,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
N_CPU    = $(or $(PARALLEL),$(NPROC),1)
# MPI tests are set up to run on 3 processes. Spread them leanly over the available processors (don't have more than 2 tests using one processor).
# e.g. run 1 MPI test at a time over 1-3 processors, or 2 tests at a time over 4-6 processors, or 3 tests over 7-9 processors, etc.
N_MPI := 3
N_MPI_TESTS = $(shell echo $$(( ($(N_CPU)+$(N_MPI)-1)/$(N_MPI) )) )

ifeq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  RUNTEST=no
endif

# some arches just aren't keeping up at all, and fail non-MPI tests
ARCH_SKIP_ALL_TESTS_LIST = mips64el hurd-i386 m68k sh4

# monitor slow python tests
export PYBUILD_TEST_ARGS = --durations=20

empty :=
space := $(empty)$(empty)

# some tests do not converge on some arches
# test_nonlinear_pde, test_petsc_solver_wrappers.py TestPETScSolverWrappers.test_compare_solvers
# "Newton solver did not converge because maximum number of iterations reached"
SKIP_NONLINEAR_PDE_TEST_ARCH_LIST = mips64el ppc64
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_NONLINEAR_PDE_TEST_ARCH_LIST)$(space)))
    SKIP_TEST_LIST += test_nonlinear_pde test_compare_solvers
endif

# skip slowest tests on riscv64, which is most of them
ifeq ($(DEB_HOST_ARCH),riscv64)
    SKIP_TEST_LIST += test_symmetry test_curl_curl_eigenvalue test_higher_order_function test_eigen_assembly \
	test_assembler test_fem_pipeline test_dof_permuting test_dofmap test_element_integrals test_xdmf_function \
	test_assemble_submesh test_interpolation test_petsc_discrete_operators test_mesh test_higher_order_mesh
endif

export PYBUILD_TEST_ARGS += $(shell \
        SKIP_TESTS=""; \
        list_initialised=0; \
        for t in $(SKIP_TEST_LIST); do \
            if [ $${list_initialised} = 0 ]; then \
                SKIP_TESTS=$$t; \
                list_initialised=1; \
            else \
                SKIP_TESTS="$${SKIP_TESTS} or $$t"; \
            fi; \
        done; \
        if [ "x$${SKIP_TESTS}" != "x" ]; then \
            SKIP_TESTS="not ( $${SKIP_TESTS} )"; \
        fi; \
        echo "-k \"$${SKIP_TESTS}\"")

# extract PETSc version from petsc-dev
PETSC_DEB_VERSION=$(shell dpkg -s petsc-dev | awk '/Version:/ {print $2}')
# extract the current PETSc version
PETSC_UPSTREAM_VERSION=$(shell pkg-config --modversion PETSc)
# "Major" version is the first number in the upstream version (major.minor.release)
PETSC_MAJOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
# "Minor" version is the second number in the upstream version (major.minor.release)
PETSC_MINOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
PETSC_VERSION=$(PETSC_MAJOR_VERSION).$(PETSC_MINOR_VERSION)
PETSC_VERSION_NEXT=$(shell echo $(PETSC_MAJOR_VERSION).$$(($(PETSC_MINOR_VERSION)+1)))

SLEPC_UPSTREAM_VERSION=$(shell pkg-config --modversion SLEPc)
# SLEPc version must match PETSc
SLEPC_VERSION=$(PETSC_VERSION)
SLEPC_VERSION_NEXT=$(PETSC_VERSION_NEXT)

PETSC_DIR_BASE=/usr/lib/petscdir/petsc$(PETSC_VERSION)/$(DEB_HOST_MULTIARCH)
SLEPC_DIR_BASE=/usr/lib/slepcdir/slepc$(SLEPC_VERSION)/$(DEB_HOST_MULTIARCH)
export PETSC_DIR_REAL=$(PETSC_DIR_BASE)-real
SLEPC_DIR_REAL=$(SLEPC_DIR_BASE)-real
export PETSC_DIR_COMPLEX=$(PETSC_DIR_BASE)-complex
SLEPC_DIR_COMPLEX=$(SLEPC_DIR_BASE)-complex

DEB_CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)

ifeq ($(DEB_HOST_ARCH),mips64el)
  DEB_CXXFLAGS += -Wno-error=maybe-uninitialized
endif

CMAKE_OPTS := \
	-D CMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-D BUILD_SHARED_LIBS:BOOL=ON \
	-D CMAKE_SKIP_RPATH:BOOL=ON \
	-D CMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-D DOLFINX_ENABLE_TRILINOS:BOOL=OFF \
	-D DOLFINX_ENABLE_HDF5:BOOL=ON \
	-D HDF5_C_COMPILER_EXECUTABLE:FILEPATH=/usr/bin/h5pcc \
	-D DOLFINX_ENABLE_PARMETIS:BOOL=OFF \
	-D DOLFINX_ENABLE_SCOTCH:BOOL=ON \
	-D DOLFINX_ENABLE_DOCS:BOOL=OFF \
	-D DOLFINX_ENABLE_MPI:BOOL=$(ENABLE_MPI) \
	-D MPIEXEC_PARAMS:STRING="$(MPIEXEC_PARAMS)" \
	-D CMAKE_CXX_FLAGS:STRING="-fpermissive" \
	-D DOLFINX_EXTRA_CXX_FLAGS:STRING="$(DEB_CXXFLAGS)" \
	-D DEBIAN_VERSION_ID=$(DEBIAN_VERSION_ID) \
	$(XSIMD_CONFIG)

%:
	dh $@ --buildsystem=cmake --with python3,sphinxdoc

override_dh_compress:
	dh_compress -X.py -X.cpp -X.h -X.pdf -X.ufl

override_dh_auto_clean:
	dh_auto_clean --builddir=$(BUILDDIR_REAL)
	dh_auto_clean --builddir=$(BUILDDIR_COMPLEX)
	rm -rf python/build-real python/build-complex
	rm -rf debian/tmp-real debian/tmp-complex
	rm -rf python/fenics_dolfinx.egg-info
	rm -rf python/doc/build python/doc/source/generated
	rm -rf cpp/doc/latex cpp/doc/html cpp/doc/xml
	rm -rf $(CURDIR)/python/doc/source/demos

override_dh_auto_configure:
	PETSC_DIR=$(PETSC_DIR_REAL) SLEPC_DIR=$(SLEPC_DIR_REAL) dh_auto_configure --builddir=$(BUILDDIR_REAL) -D$(CURDIR)/cpp -- $(CMAKE_OPTS)
	PETSC_DIR=$(PETSC_DIR_COMPLEX) SLEPC_DIR=$(SLEPC_DIR_COMPLEX) dh_auto_configure --builddir=$(BUILDDIR_COMPLEX) -D$(CURDIR)/cpp -- $(CMAKE_OPTS)

override_dh_auto_build:
	PETSC_DIR=$(PETSC_DIR_REAL) SLEPC_DIR=$(SLEPC_DIR_REAL) dh_auto_build --builddir=$(BUILDDIR_REAL)
	PETSC_DIR=$(PETSC_DIR_COMPLEX) SLEPC_DIR=$(SLEPC_DIR_COMPLEX) dh_auto_build --builddir=$(BUILDDIR_COMPLEX)

override_dh_auto_test-arch:
	echo "Tests must be run after installation"

override_dh_auto_test-indep:

debian/tmp-real:
	dh_auto_install --builddir=$(BUILDDIR_REAL) --destdir=debian/tmp-real
	cp COPYING.LESSER python
	for build in real; do \
		PATH=$(CURDIR)/debian/tmp-$${build}/usr/bin:$$PATH \
		PETSC_DIR=$(PETSC_DIR_BASE)-$${build} SLEPC_DIR=$(SLEPC_DIR_BASE)-$${build} \
		CXXFLAGS="$(DEB_CXXFLAGS) -isystem $(CURDIR)/debian/tmp-$${build}/usr/include" \
		VERBOSE=1 \
		ADIOS2_ALWAYS_USE_MPI=1 \
		PUSIMP_EXPECT_DOLFINX_IN_CWD=1 \
		pybuild --dir=$(CURDIR)/python --dest-dir=$(CURDIR)/debian/tmp-$${build} --system=pyproject --name=dolfinx-$${build} --test-pytest; \
	done

override_dh_auto_install-indep: debian/tmp-real
	dh_auto_install -i --builddir=$(BUILDDIR_COMPLEX) --destdir=debian/tmp-complex
	(cd cpp/doc; doxygen)
	(cd python/doc; \
	  mkdir -p build/pkgconfig; \
	  cp $(CURDIR)/debian/tmp-real/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/dolfinx_real.pc build/pkgconfig; \

=== debian/tests/control ===
Tests: test-dolfinx-cpp,
 test-dolfinx-cpp-complex,
Depends: @, @builddeps@,
Restrictions: allow-stderr

Tests: test-dolfinx-python-unittests,
 test-dolfinx-python-demos
Depends: @, @builddeps@,
	  python3-all-dev,
	  python3-pytest,
	  python3-decorator,
	  python3-matplotlib,
	  python3-scipy

Tests: test-dolfinx-python-complex-unittests,
 test-dolfinx-python-complex-demos
Depends: @, @builddeps@,
	  python3-all-dev,
	  python3-pytest,
	  python3-decorator,
	  python3-matplotlib,
	  python3-scipy

Tests: test-dolfinx-python-pusimp
Architecture: !riscv64
Depends: @, @builddeps@,
 python3-all,
 python3-pip,
 python3-pytest,
 python3-requests,
 python3-virtualenv
Restrictions: needs-internet

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/FEniCS/dolfinx/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
